// Code generated by adapter-generator. DO NOT EDIT.

package adapter

import (
	"google.golang.org/protobuf/proto"
	. "go.ligato.io/vpp-agent/v3/plugins/kvscheduler/api"
	"go.ligato.io/vpp-agent/v3/plugins/vpp/wireguardplugin/wgidx"
	"go.ligato.io/vpp-agent/v3/proto/ligato/vpp/wireguard"
)

////////// type-safe key-value pair with metadata //////////

type PeerKVWithMetadata struct {
	Key      string
	Value    *vpp_wg.Peer
	Metadata *wgidx.WgMetadata
	Origin   ValueOrigin
}

////////// type-safe Descriptor structure //////////

type PeerDescriptor struct {
	Name                 string
	KeySelector          KeySelector
	ValueTypeName        string
	KeyLabel             func(key string) string
	ValueComparator      func(key string, oldValue, newValue *vpp_wg.Peer) bool
	NBKeyPrefix          string
	WithMetadata         bool
	MetadataMapFactory   MetadataMapFactory
	Validate             func(key string, value *vpp_wg.Peer) error
	Create               func(key string, value *vpp_wg.Peer) (metadata *wgidx.WgMetadata, err error)
	Delete               func(key string, value *vpp_wg.Peer, metadata *wgidx.WgMetadata) error
	Update               func(key string, oldValue, newValue *vpp_wg.Peer, oldMetadata *wgidx.WgMetadata) (newMetadata *wgidx.WgMetadata, err error)
	UpdateWithRecreate   func(key string, oldValue, newValue *vpp_wg.Peer, metadata *wgidx.WgMetadata) bool
	Retrieve             func(correlate []PeerKVWithMetadata) ([]PeerKVWithMetadata, error)
	IsRetriableFailure   func(err error) bool
	DerivedValues        func(key string, value *vpp_wg.Peer) []KeyValuePair
	Dependencies         func(key string, value *vpp_wg.Peer) []Dependency
	RetrieveDependencies []string /* descriptor name */
}

////////// Descriptor adapter //////////

type PeerDescriptorAdapter struct {
	descriptor *PeerDescriptor
}

func NewPeerDescriptor(typedDescriptor *PeerDescriptor) *KVDescriptor {
	adapter := &PeerDescriptorAdapter{descriptor: typedDescriptor}
	descriptor := &KVDescriptor{
		Name:                 typedDescriptor.Name,
		KeySelector:          typedDescriptor.KeySelector,
		ValueTypeName:        typedDescriptor.ValueTypeName,
		KeyLabel:             typedDescriptor.KeyLabel,
		NBKeyPrefix:          typedDescriptor.NBKeyPrefix,
		WithMetadata:         typedDescriptor.WithMetadata,
		MetadataMapFactory:   typedDescriptor.MetadataMapFactory,
		IsRetriableFailure:   typedDescriptor.IsRetriableFailure,
		RetrieveDependencies: typedDescriptor.RetrieveDependencies,
	}
	if typedDescriptor.ValueComparator != nil {
		descriptor.ValueComparator = adapter.ValueComparator
	}
	if typedDescriptor.Validate != nil {
		descriptor.Validate = adapter.Validate
	}
	if typedDescriptor.Create != nil {
		descriptor.Create = adapter.Create
	}
	if typedDescriptor.Delete != nil {
		descriptor.Delete = adapter.Delete
	}
	if typedDescriptor.Update != nil {
		descriptor.Update = adapter.Update
	}
	if typedDescriptor.UpdateWithRecreate != nil {
		descriptor.UpdateWithRecreate = adapter.UpdateWithRecreate
	}
	if typedDescriptor.Retrieve != nil {
		descriptor.Retrieve = adapter.Retrieve
	}
	if typedDescriptor.Dependencies != nil {
		descriptor.Dependencies = adapter.Dependencies
	}
	if typedDescriptor.DerivedValues != nil {
		descriptor.DerivedValues = adapter.DerivedValues
	}
	return descriptor
}

func (da *PeerDescriptorAdapter) ValueComparator(key string, oldValue, newValue proto.Message) bool {
	typedOldValue, err1 := castPeerValue(key, oldValue)
	typedNewValue, err2 := castPeerValue(key, newValue)
	if err1 != nil || err2 != nil {
		return false
	}
	return da.descriptor.ValueComparator(key, typedOldValue, typedNewValue)
}

func (da *PeerDescriptorAdapter) Validate(key string, value proto.Message) (err error) {
	typedValue, err := castPeerValue(key, value)
	if err != nil {
		return err
	}
	return da.descriptor.Validate(key, typedValue)
}

func (da *PeerDescriptorAdapter) Create(key string, value proto.Message) (metadata Metadata, err error) {
	typedValue, err := castPeerValue(key, value)
	if err != nil {
		return nil, err
	}
	return da.descriptor.Create(key, typedValue)
}

func (da *PeerDescriptorAdapter) Update(key string, oldValue, newValue proto.Message, oldMetadata Metadata) (newMetadata Metadata, err error) {
	oldTypedValue, err := castPeerValue(key, oldValue)
	if err != nil {
		return nil, err
	}
	newTypedValue, err := castPeerValue(key, newValue)
	if err != nil {
		return nil, err
	}
	typedOldMetadata, err := castPeerMetadata(key, oldMetadata)
	if err != nil {
		return nil, err
	}
	return da.descriptor.Update(key, oldTypedValue, newTypedValue, typedOldMetadata)
}

func (da *PeerDescriptorAdapter) Delete(key string, value proto.Message, metadata Metadata) error {
	typedValue, err := castPeerValue(key, value)
	if err != nil {
		return err
	}
	typedMetadata, err := castPeerMetadata(key, metadata)
	if err != nil {
		return err
	}
	return da.descriptor.Delete(key, typedValue, typedMetadata)
}

func (da *PeerDescriptorAdapter) UpdateWithRecreate(key string, oldValue, newValue proto.Message, metadata Metadata) bool {
	oldTypedValue, err := castPeerValue(key, oldValue)
	if err != nil {
		return true
	}
	newTypedValue, err := castPeerValue(key, newValue)
	if err != nil {
		return true
	}
	typedMetadata, err := castPeerMetadata(key, metadata)
	if err != nil {
		return true
	}
	return da.descriptor.UpdateWithRecreate(key, oldTypedValue, newTypedValue, typedMetadata)
}

func (da *PeerDescriptorAdapter) Retrieve(correlate []KVWithMetadata) ([]KVWithMetadata, error) {
	var correlateWithType []PeerKVWithMetadata
	for _, kvpair := range correlate {
		typedValue, err := castPeerValue(kvpair.Key, kvpair.Value)
		if err != nil {
			continue
		}
		typedMetadata, err := castPeerMetadata(kvpair.Key, kvpair.Metadata)
		if err != nil {
			continue
		}
		correlateWithType = append(correlateWithType,
			PeerKVWithMetadata{
				Key:      kvpair.Key,
				Value:    typedValue,
				Metadata: typedMetadata,
				Origin:   kvpair.Origin,
			})
	}

	typedValues, err := da.descriptor.Retrieve(correlateWithType)
	if err != nil {
		return nil, err
	}
	var values []KVWithMetadata
	for _, typedKVWithMetadata := range typedValues {
		kvWithMetadata := KVWithMetadata{
			Key:      typedKVWithMetadata.Key,
			Metadata: typedKVWithMetadata.Metadata,
			Origin:   typedKVWithMetadata.Origin,
		}
		kvWithMetadata.Value = typedKVWithMetadata.Value
		values = append(values, kvWithMetadata)
	}
	return values, err
}

func (da *PeerDescriptorAdapter) DerivedValues(key string, value proto.Message) []KeyValuePair {
	typedValue, err := castPeerValue(key, value)
	if err != nil {
		return nil
	}
	return da.descriptor.DerivedValues(key, typedValue)
}

func (da *PeerDescriptorAdapter) Dependencies(key string, value proto.Message) []Dependency {
	typedValue, err := castPeerValue(key, value)
	if err != nil {
		return nil
	}
	return da.descriptor.Dependencies(key, typedValue)
}

////////// Helper methods //////////

func castPeerValue(key string, value proto.Message) (*vpp_wg.Peer, error) {
	typedValue, ok := value.(*vpp_wg.Peer)
	if !ok {
		return nil, ErrInvalidValueType(key, value)
	}
	return typedValue, nil
}

func castPeerMetadata(key string, metadata Metadata) (*wgidx.WgMetadata, error) {
	if metadata == nil {
		return nil, nil
	}
	typedMetadata, ok := metadata.(*wgidx.WgMetadata)
	if !ok {
		return nil, ErrInvalidMetadataType(key)
	}
	return typedMetadata, nil
}
